batch
/* ***************************************************************************
           FILE NAME: HP4UNITS.UC
         DESCRIPTION: Machine Parameters Conversion File for Newing Hall HP4
       CREATION DATE: 01/05/98
              AUTHOR: Craig Sior
           COPYRIGHT: (c) 1997 ExtraTech Corporation - ALL RIGHTS RESERVED
    REVISION HISTORY: V1.00  01/05/98 CAS Initial Creation
**  V1.01  02/22/99 SAW Added __Units, changed logic to determin what to do,
**                  added more values and call set_units at end of file.  Also set batch.
**  V1.02  03/17/99 SAW Added 170 for default Cylindrical Mode Translation Diameter
*************************************************************************** */

` NOTES: 57  = Units
`       200  = Units string (mm or in.)
`

/* Units Conversion */
ifmissing __UNITS 0 ivar __UNITS
__UNITS not #ifdef
true == __UNITS

ifmissing NUM_AXES      3 ivar NUM_AXES

0 ivar ?CONVERT_TO_MM
25.4 fvar factor
0 ivar AXIS

` <location> convert        ` USE FOR DIMENS and rates
: convert dup get_float
	?CONVERT_TO_MM if factor f* else factor f/ endif set_float ;

` <location> convert_down        ` USE FOR RESOLUTION
: convert_down dup get_float
	?CONVERT_TO_MM if factor f/ else factor f* endif set_float ;

: set_units ` 2drop
    57 get_integer if 0 else 1 endif
    dup 57 set_integer == ?CONVERT_TO_MM
    57 get_integer if "" mm" else "" in." endif 200 set_string
	0 NUM_AXES 1- 1 step
		` do rates
		I 10 * == AXIS
		0 7 1 step      ` do rates
            I 4 <> if                        ` skip 4
            500 AXIS + I + convert
            I 3 = if 500 AXIS + I + convert endif  ` do vertex accel squared
            endif
		endstep
		` do dimensions
		 1 I + convert_down     ` resolution
		 5 I + convert          ` neg table size
		 9 I + convert          ` pos table size
		13 I + convert          ` limit park offset
	endstep
	0 == AXIS
    ` calculate preserved homes and preset soft_homes.
    110 131 1 step
        I convert
    endstep
    ` Get the rest of them.
    22 convert          ` arc set res
    31 convert          ` cut depth
    37 convert          ` cut speed
    38 convert          ` plunge speed
    39 convert          ` lift speed
    40 convert          ` lift height
    42 convert          ` contouring acceleration
    43 convert_down     ` hpgl xy scale
    44 convert_down     ` hpgl z scale
    45 convert          ` datum high speed
    46 convert          ` datum low speed
    47 convert          ` Z datum high speed
    58 convert          ` X Cyl Max Velocity
    61 convert          ` test_origin error allowance
    68 convert          ` restart tolerance
    80 convert          ` X tool offset
    81 convert          ` Y tool offset
   170 convert          ` X Cylindrical Diameter Default
	;

#endif
set_units
nl bell "  RESTARTING MACHINE PARAMETERS <-" nl
COLD

batch_off
