/* LMCI NH Self-test file.  **
#MODULE INI_SELFTEST   #VERSION 2.04
-- */
2.04 fvar ST_VERSION
/* -- 
** 2.04 10/10/12 CAS Show number of loops running. FST was leaving a numuber on stack.
** 2.03 08/27/12 CAS If you press Pause, it will cancel after finishing the operation.
** 2.02 07/05/12 CAS Bail out of most routines if estop is detected.
**                   If machine didn't have a controlled Z, the turbo key wouldn't work for the keypad test.
** 2.01 06/22/12 CAS Could not recover from Estop.
** 2.00 02/27/12 CAS New for RP4 Init (Supports KDM8g too)

** 1.00 02/05/98 FJA Adapter for HP4.
** 1.01 04/30/98 CAS Added spindle test, Z motion to tests.
** 1.02 05/11/98 CAS Added Set Home, Set Surface.
** 1.03 08/11/98 CAS Added check for controlled_Z
** 1.04 08/14/98 CAS Increased SIZE from 5. to 10., repeats 5 times,
**                   added fst to repeat until terminal input.
** 1.05 02/26/99 SAW Added inch_to_mm to make sure SIZE is correct for type of measurements.
** 1.06 03/12/99 SAW Removed clr as it was causing ISP stack error when returning to the menu.
**                   Added PEN# to mot_pat_sxc so that ?manual_tool won't ask for the PEN
** 1.07 03/12/99 SAW Typo #PEN changed to PEN#
** 1.08 06/16/99 SAW Updated kdm_set_intr and set_key_intr to use kdm_keyintr instead.  Found extra three causing
**                   "WARNING: Possible IStack error" message on each PD
** 1.09 08/06/99 SAW put checkstack? in to keep from receiving stack warnings if run from the menu. for init v2.65
**
** self_test_mode flag is set using SETUP.
**      1       perform KDM test
**      2       perform cartesian motion test
**      4       perform origin test (limit switches required)
**
** scales in 1, 2, 3 get_float
**
** ST_ERROR bit
**	1		x-axis CTR error
**	2		y-axis CTR error
**  4       Paused (Pause key)
**  8       Halt Signal (limit or estop)
** */
decimal
` removed the CLR as it was causing errors when running from a fresh booted controller, using the menu.
` 3 -- don't know why this three was here, but after the clr was removed it was being left on the stack.
60 get_integer ivar SELF_TEST_MODE ` clr


ifmissing start_motion  : start_motion enable_motion ;
ifmissing no_home		: no_home start_motion ;

40	allocate ptr STR
0	ivar ST_ERROR
128 ivar REG_ERROR
256 ivar CTR_ERROR

: error_display
	dup 1 and if "  X-axis" endif
	dup 2 and if "  Y-axis" endif
	dup 4 and if "  Pause/Canclled" endif
    dup REG_ERROR and if "  7166 Reg\n" endif
    dup CTR_ERROR and if "  7166 Cnt\n" endif
	drop ;

: do_error or dup ST_ERROR or == ST_ERROR error_display ;
: ms 1000 millisecond_delay ;

-1 ivar STJOBT
0 ivar PSTJOBT
: dsp_st_time
    STJOBT 0 <= if :exit endif 
ifexists TimeToStrRaw get_rtc_clk STJOBT - 500 / dup PSTJOBT <> if dup == PSTJOBT TimeToStrRaw dup slen kdm_config? swap drop - neg 0 pos kdm_dsp_string else drop endif
;

0 ivar xorigin
0 ivar yorigin
0 ivar zorigin
0. fvar xforigin     ` fvar version of origin
0. fvar yforigin

/* KDM8.UC 01/24/96 KDM8 test setup file */
0 ivar KEYS_PRESSED
0 ivar KEYS_RELEASED
0 ivar INVALID_KEY

0 set_warning
: kdm_dsp_line dup kdm_dsp_line nl s. ;
1 set_warning

: all_leds_off 0 led_off 1 led_off 2 led_off 3 led_off 4 led_off 5 led_off 6 led_off 7 led_off ;

: keyclr 100 millisecond_delay loop 0 kdm_scankey -1 <> if 1 kdm_scankey drop 200 millisecond_delay else break endif repeat  ;
: keywatch 0
	1 12 1 step
		1 led_on 40 millisecond_delay 1 led_off
		200 millisecond_delay 0 kdm_scankey -1 <>
		if drop 1 break endif
		ST_ERROR if break endif 
	endstep ;
: key_pad? KDMDVC> w@ 0 > KDMDVC> w@ 8 < and
	dup not if -99 == KEYS_PRESSED endif ;

	
: get_key_str
    127 and 
    dup 0 = if "" Number 0"     else ` key code 0
    dup 1 = if "" Number 1"	    else ` key code 1 
    dup 2 = if "" Number 2"     else ` key code 2
    dup 3 = if "" Number 3"     else ` key code 3
    dup 4 = if "" Number 4"     else ` key code 4
    dup 5 = if "" Number 5"     else ` key code 5
    dup 6 = if "" Number 6"     else ` key code 6
    dup 7 = if "" Number 7"     else ` key code 7
    dup 8 = if "" Number 8"     else ` key code 8
    dup 9 = if "" Number 9"     else ` key code 9
    dup 11 = if "" Drives On"   else ` key code 11
    dup 12 = if "" Enter Key"   else ` key code 12
    dup 13 = if "" Exit Key"    else ` key code 13
    dup 40 = if "" Decimal Pt." else ` key code 40
    dup 44 = if "" Turbo Key"   else ` key code 44
    dup 43 = if "" Flat/Cyl"    else 
    dup 25 = if "" Up Arrow"    else
    dup 26 = if "" Right Arrow" else
    dup 28 = if "" Jog Z"       else
    dup 15 = if "" Left Arrow"  else
    dup 24 = if "" Down Arrow"  else
    dup 58 = if "" Start key"   else
    dup 49 = if "" Pause key"   else 
                "" Invalid Key" dup s. sp. over . nl 1 == INVALID_KEY 
    endif endif endif endif endif endif endif endif endif endif endif endif endif endif endif endif endif endif endif endif endif endif endif
    swap drop 
	;
KDM8G? #ifdef 	
: make_st_keyb
    /* <code> */ glcd_create_control  9000 glcd_control_group glcd_control_insensitive ` do not allow touch events
    ` Color <Background> <Border> <Surface> <Forground>
    cTRANSPARENT cBLACK cYELLOW cTEXT_COLOR 
    cTRANSPARENT cBLACK cWHITE  cTEXT_COLOR 0xFF00 glcd_control_colors
    20 20 glcd_control_extents  
    bury glcd_draw_control drop 
;
: draw_keyboard
       28 22 kdm_key_table  ` Z Jog  ` If NOT controlled Z, this will be mapped to 44 which will not work.

    230 100 9011 make_st_keyb  ` 11 drives
    260 100 9000 make_st_keyb  ` 0 
    290 100 9040 make_st_keyb  ` 40 decimal P.
    230  70 9001 make_st_keyb  ` 1
    260  70 9002 make_st_keyb  ` 2
    290  70 9003 make_st_keyb  ` 3
    230  40 9004 make_st_keyb  ` 4
    260  40 9005 make_st_keyb  ` 5
    290  40 9006 make_st_keyb  ` 6
    230  10 9007 make_st_keyb  ` 7
    260  10 9008 make_st_keyb  ` 8
    290  10 9009 make_st_keyb  ` 9
    
    180 100 9043 make_st_keyb  ` Flat/Cyl
    150 100 9049 make_st_keyb  ` Pause
    120 100 9058 make_st_keyb  ` Start
    
     70 100 9044 make_st_keyb  ` Turbo
     40 100 9013 make_st_keyb  ` Cancel
     10 100 9012 make_st_keyb  ` Enter
     
     40  10 9025 make_st_keyb  ` Up Arro2
     10  35 9015 make_st_keyb  ` Left Arrow
     40  35 9028 make_st_keyb  ` Jog Z
     70  35 9026 make_st_keyb  ` Right Arrow
     40  60 9024 make_st_keyb  ` Down Arrow
;
#endif

: mb! swap b! ;
256 999 sysallocate ptr pK
: initPK pK + dup 1 mb! 128 + 1 mb! ;
: clear_pK  0 255 1 step 0 pK I + b! endstep
     0 initPK     1 initPK     2 initPK     3 initPK     4 initPK     5 initPK      
     6 initPK     7 initPK     8 initPK     9 initPK    11 initPK    12 initPK        
    13 initPK    28 initPK    40 initPK    44 initPK    58 initPK    49 initPK        
    24 initPK    25 initPK    26 initPK    15 initPK    43 initPK       
    ;
: test_keys
	0 == INVALID_KEY
    clear_pK
    [ KDM8G? ] #ifdef
        erase_display
        3 kdm_lines
        draw_keyboard
    #endif
    loop
        0 kdm_scankey -1 <> if
            1 kdm_scankey
            dup pK + 0 swap b! ` mark key that was pressed.
            0 0 255 1 step pK I + b@ + endstep ` check if any remaining.
            0 = if drop break endif
            dup 127 > if                        ` Show wheter the key was a make or break.
                127 and "" Released " kdm_dsp_line ` filter out the break code, so following display of message is correct.
                [ KDM8G? ] #ifdef dup 9000 + glcd_deactivate_control 40 0x200 glcd_control_colors drop #endif ` change to grey once released.
                   else "" Pressed  " kdm_dsp_line
                [ KDM8G? ] #ifdef dup 9000 + glcd_activate_control drop #endif 
            endif
            0 1 pos get_key_str kdm_dsp_string  ` Display the message for the key.
            [ KDM8G? ] #ifdef
                0 0 255 1 step pK I + b@ + endstep    
                0 2 pos kdm_dspnum ""  Remaining   "  kdm_dsp_string ` display how many remaining ` ""  Remaining        "
            #endif
        endif
        111 port_input? 15 and ST_ERROR or if 8 == ST_ERROR break endif ` if error happens, like estop, get out.         
    repeat
    ?CONTROLLED_Z if 
        28 22 kdm_key_table  ` Z Jog
    else
        44 22 kdm_key_table  ` Z Jog
    endif
	INVALID_KEY if
		"" Pendant Failed." kdm_dsp_line
		"  Unknown Key Pressed\n"
		kdm_getkey drop 
	endif
	[ KDM8G? ] #ifdef 9000 glcd_destroy_group drop clear_display #endif
    kon ;

: test_leds
    111 port_input? 15 and ST_ERROR or if 8 == ST_ERROR :exit endif  
    2 led_on
	"" START Led On?" kdm_dsp_line	kdm_getkey drop
	2 led_blink
	0 led_on
	"" STOP Led On?" kdm_dsp_line	kdm_getkey drop
	0 led_blink
	6 led_on
	"" FLAT/CYL Led On?" kdm_dsp_line	kdm_getkey drop
	6 led_blink
	1 led_on
    "" (Spare) Led On?" kdm_dsp_line    kdm_getkey drop
	1 led_blink
	4 led_on
    "" Spindle Led On?" kdm_dsp_line    kdm_getkey drop
	4 led_blink
	5 led_on
	"" AUX1 Led On?" kdm_dsp_line	kdm_getkey drop
	5 led_blink
	3 led_on
	"" AUX2 Led On?" kdm_dsp_line	kdm_getkey drop
	3 led_blink
	"" All Leds Blinking?" kdm_dsp_line	kdm_getkey drop
	all_leds_off ;

: kdm8
	koff
	-2 kdm_pause_key
	keyclr
	test_keys
	test_leds
	36 kdm_pause_key ;

` Added inch_to_mm in case values set to metric
10. inch_to_mm fvar SIZE

0. fvar xpos
0. fvar ypos

: chkr0 dup 0 set_pos 128 get_pos? <> if REG_ERROR 1 do_error endif ;
: chkr1 dup 1 set_pos 129 get_pos? <> if REG_ERROR 2 do_error endif ;
: mot_reg_test
        chk_any_motion? not 111 port_input? 15 and or if 8 == ST_ERROR :exit endif
        ST_ERROR if :exit endif 
	    0 dup chkr0 chkr1
	    1 dup chkr0 chkr1
	    2 dup chkr0 chkr1
	  128 dup chkr0 chkr1
	65535 dup chkr0 chkr1
	   -1 dup chkr0 chkr1
	;

: tm == ypos == xpos
    chk_any_motion? not 111 port_input? 15 and or if 8 == ST_ERROR :exit endif
    ST_ERROR if :exit endif 
    SYS_MSG? 8 and if " Motion " xpos f. sp. ypos f. nl endif 
	xpos ypos AC 
	` update the XYZ position if kdm8g version.
    ifexists update_xyz_box_when_moving fp update_xyz_box_when_moving
	wait_plot
    dsp_st_time ` display time on keypad if we should
    0 get_pos? xpos f- xforigin f- 1 get_float f* fabs 1. f> if CTR_ERROR 1 do_error endif
    1 get_pos? ypos f- yforigin f- 2 get_float f* fabs 1. f> if CTR_ERROR 2 do_error endif
	;

5 ivar #pat_repeat

: mot_pat_sxc
    "" Motion Test..." kdm_dsp_line
    0 == PEN#
    2 kdm_integer_size
    1 #pat_repeat 1 step   ` Added PEN# so that it won't ask if ?MANUAL_TOOL
        [ KDM8G? ] #ifdef
            0 1 pos "" Pattern " kdm_dsp_string I kdm_dspnum
                    ""  of  "    kdm_dsp_string #pat_repeat kdm_dspnum
        #endif
        1 PD
        SIZE 0. tm
        SIZE SIZE tm
        0. SIZE tm
        0. 0. tm
        SIZE SIZE tm
        1 PU
        0. SIZE tm
        1 PD
        SIZE 0. tm
        1 PU
        SIZE SIZE 0.5 f* tm
        1 PD
        SIZE 0.5 f* fdup fdup 0. 360. R
        1 PU
        0. 0. tm
       wait_plot
        chk_any_motion? not 111 port_input? 15 and or if 8 == ST_ERROR break endif
        ST_ERROR if break endif 
    endstep
    8 kdm_integer_size
	;
: motion_pattern
    ` " Motion Pattern: stack(" #istk . " )\n" 
	start_motion
	[ hex ] mpg_active? 10000 and not if error_blink :exit endif [ decimal ]
    128 get_pos? == xorigin 0 get_pos? == xforigin
    129 get_pos? == yorigin 1 get_pos? == yforigin
    130 get_pos? == zorigin
    mot_reg_test ST_ERROR if :exit endif
    xorigin 0 set_pos
    yorigin 1 set_pos
    zorigin 2 set_pos
    ` #set_origin   ` make here be the origin
	mot_pat_sxc  ST_ERROR if :exit endif
	;

0. fvar prct
0. fvar vel

: st_duty_error            ` <percent>
    dup 180 100 i*/ 100 rot - 180 100 i*/ 
	1 10 1 step
	    0 kdm_scankey -1 <> if break endif  	
        2 led_on over #delay 2 led_off dup #delay
	endstep 2drop ;
: st_error_blink 75 st_duty_error ; ` create this one so it looks for key presses.
: fself_test
    5 host_mode     ` set host mode so that e-stop does automatic cancel
    nl 0 == ST_ERROR
    false == checkstack?        ` used to turn off stack checking so running from menu wont give warnings
    menu_status? if menu_leave endif 
    ifexists kdm_lines 3 kdm_lines
    2 blinks "" Initiating Self-test Version "
    ifexists word_wrap_string word_wrap_string
    kdm_dsp_line
    ST_VERSION fdup 2 kdm_dspfnum 2 fprec f. 4 fprec ms
    key_pad? not if
        " No keypad defined." nl
    else
        SELF_TEST_MODE 1 and if
            100 millisecond_delay INDVC> w@ 19 0 ioctl drop
            koff keyclr
            "" Depress key button?" kdm_dsp_line
            keywatch
        else 0 endif
        if
            50 millisecond_delay keyclr kdm8
        else
            -9 kdm_menu_enter_key ` remap so menu cannot screw up our test.
            "" Skipping Keypad Test" kdm_dsp_line ms
        endif
	endif
    SELF_TEST_MODE 8 and ST_ERROR not land if   ` is spindle test selected
        1 1000 spindle_speed  ` set to min rpm
        spindle_on
        "" Turning Spindle ON" kdm_dsp_line ms
        49 get_integer 1000 - 2 / 1000 + 1 swap spindle_speed ` set to mid range
        ms
        1 49 get_integer spindle_speed  ` set to max range
        ms
        "" Turning Spindle OFF" kdm_dsp_line ms
        spindle_off
    endif
    SELF_TEST_MODE 2 and ST_ERROR not land if
        "" Motion Test." kdm_dsp_line ms
		mon 1 == ?DRIVE_ON
        ` wait for user to set home if not set.
        kon
        loop
            ?HOMESET not if 1081 getmsg dup s. nl kdm_dsp_line 2 second else break endif ` "" Please Set Home."
            111 port_input? 15 and ST_ERROR or if 8 == ST_ERROR break endif ` break out for any error condition 
        repeat
        ?CONTROLLED_Z if
            ` ask to set surface if NOT set
            0. Z_SURFACE f= if end_motion koff key_func6 kon endif
        endif
        start_motion
		2 led_on
        111 port_input? 15 and not ST_ERROR not land if  
    		motion_pattern
        endif
		moff 0 == ?DRIVE_ON
	endif
	ST_ERROR not if 
    	2 led_off
        SELF_TEST_MODE 4 and if
            "" Origin Test." kdm_dsp_line ms
            mon 1 == ?DRIVE_ON
            test_origin
        else
            "" Skipping Origin Test" kdm_dsp_line ms
        endif
        2 led_off
    endif
	"" End Self Test." kdm_dsp_line
	ifexists check_for_faults check_for_faults write_err
    SYS_MSG? 8 and if " ST_ERROR= " ST_ERROR . nl endif 
	ST_ERROR if koff loop kdm_intr? if koff endif st_error_blink 0 kdm_scankey -1 <> if 1 kdm_scankey dup . nl 13 128 + = if break endif endif repeat endif
	nl "" End Self Test." SYS_MSG? 8 and if dup s. nl endif kdm_dsp_line ms
    12 kdm_menu_enter_key             ` start the menu
    KEYS_PRESSED -99 <> if kon endif   ` skip keypad if nec
    end_motion
    true == checkstack?
    -1 kdm_stroke
	leave  ` if this is being run from flash, leave to exit. 	
	;
0 set_warning
ifmissing kdm_dsp_status : kdm_dsp_status drop 0 2 pos kdm_dsp_string ;
: key_func49
    4 == ST_ERROR
    "" Cancelling..." 3 kdm_dsp_status    
    ifexists key_func49 key_func49
;
0 ivar FST_CNT
: fst
    get_rtc_clk == STJOBT
    1 == FST_CNT
    " \nFST ($=Exit, h=Display info.  Checked at the start of each self_test.)\nRunning..." 
    loop 
        FST_CNT 1+ == FST_CNT 
        fself_test 
        loop 
            ?terminal if 
                rchar
                dup ascii h = if " \n\007Time : " get_rtc_clk STJOBT - 500 / TimeToStrRaw s. " \n\007Loop : " FST_CNT . nl endif
                    ascii $ = if 1 break endif
            else 
                0 break 
            endif
        repeat
        if break endif  
        ST_ERROR if break endif 
    repeat 
;

` This one will be called from Init file.
: fself_test -1 == STJOBT fself_test ;

in_hpgl? #ifdef 11 23 "" ;!ZX" ioctl drop #endif
in_cnc?  #ifdef 11 23 "" M99\n" ioctl drop #endif
11 23 "" \nfself_test\n" ioctl drop


